# TODO:
# - Gstreamer error: "A text/uri-list decoder plugin is required to play this stream, but not installed."
# - apply patches to libprojectM.spec and use
# - package for kde4 stuff (or nuke them):
#        /usr/share/kde4/services/clementine-feed.protocol
#        /usr/share/kde4/services/clementine-itms.protocol
#        /usr/share/kde4/services/clementine-itpc.protocol
#        /usr/share/kde4/services/clementine-zune.protocol
#
# Conditional build:
%bcond_without	static_sqlite	# with static sqlite3
%bcond_with	static_projectm	# with static projectM
%bcond_with	libspotify	# build with system libspotify instead of downloading blob

%define		qtver	%(pkg-config --silence-errors --modversion QtCore 2>/dev/null || echo ERROR)
Summary:	A music player and library organiser
Summary(hu.UTF-8):	Egy zenelejátszó és gyűjtemény-kezelő
Name:		clementine
Version:	1.1.1
Release:	6
License:	GPL v3 and GPL v2+
Group:		Applications/Multimedia
URL:		http://www.clementine-player.org/
Source0:	http://clementine-player.googlecode.com/files/%{name}-%{version}.tar.gz
# Source0-md5:	28e4afb822388bd337a761db8f86febf
Patch0:		desktop-install.patch
Patch1:		unbundle-po.patch
Patch2:		%{name}-1.1.1-libimobiledevice-fix.patch
Patch3:		%{name}-dt_categories.patch
Patch4:		%{name}-mygpo.patch
BuildRequires:	QtCore-devel >= %{qtver}
BuildRequires:	QtDBus-devel >= %{qtver}
BuildRequires:	QtGui-devel >= %{qtver}
BuildRequires:	QtIOCompressor-devel
BuildRequires:	QtNetwork-devel >= %{qtver}
BuildRequires:	QtOpenGL-devel >= %{qtver}
BuildRequires:	QtSingleApplication-devel >= 2.6-4
BuildRequires:	QtSql-devel >= %{qtver}
%{?with_tests:BuildRequires:	QtTest-devel >= %{qtver}}
BuildRequires:	QtXml-devel >= %{qtver}
BuildRequires:	QtXmlPatterns-devel >= %{qtver}
BuildRequires:	boost-devel
BuildRequires:	cmake >= 2.6
#%{?with_static_projectm:BuildRequires:	ftgl-devel >= 2.1.3}
BuildRequires:	gettext-devel
%{?with_static_projectm:BuildRequires:	glew-devel}
BuildRequires:	glib2-devel
BuildRequires:	gstreamer0.10-devel
BuildRequires:	gstreamer0.10-plugins-base-devel
BuildRequires:	gtest-devel
BuildRequires:	libcdio-devel
BuildRequires:	libchromaprint-devel
BuildRequires:	libgpod-devel >= 0.7.92
BuildRequires:	libimobiledevice-devel >= 1.1.5
BuildRequires:	libindicate-qt-devel
BuildRequires:	liblastfm-devel >= 0.3.3
BuildRequires:	libmtp-devel
BuildRequires:	libmygpo-qt-devel
BuildRequires:	libplist-devel
%{!?with_static_projectm:BuildRequires:	libprojectM-devel >= 1:2.0.1-4}
BuildRequires:	libqxt-devel
%{?with_libspotify:BuildRequires:	libspotify-devel >= 12.1.45}
BuildRequires:	libxml2-devel
BuildRequires:	pkgconfig
BuildRequires:	pkgconfig
BuildRequires:	protobuf-devel
BuildRequires:	qca-devel
BuildRequires:	qjson-devel
BuildRequires:	qt4-build >= %{qtver}
BuildRequires:	qt4-linguist
BuildRequires:	qt4-qmake
BuildRequires:	rpmbuild(find_lang) >= 1.33
BuildRequires:	rpmbuild(macros) >= 1.596
BuildRequires:	sed >= 4.0
BuildRequires:	sparsehash-devel
%{!?with_static_sqlite:BuildRequires:	sqlite3-devel}
BuildRequires:	taglib-devel >= 1.6
BuildRequires:	usbmuxd-devel
Requires(post,postun):	desktop-file-utils
Requires(post,postun):	gtk-update-icon-cache
Requires(post,postun):	hicolor-icon-theme
Requires:	QtSingleApplication >= 2.6-4
%{!?with_static_sqlite:Requires:	QtSql-sqlite3 >= %{qtver}}
Requires:	gstreamer0.10-audio-effects-base
Requires:	gstreamer0.10-mad
Suggests:	gstreamer0.10-flac

# while we do not link (yet), we use datafiles
Requires:	libprojectM
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# see libprojectM.spec for explanation
%define		filterout_ld	-Wl,--as-needed -Wl,--no-copy-dt-needed-entries

%description
Clementine is a modern music player and library organiser. It is
largely a port of Amarok 1.4, with some features rewritten to take
advantage of Qt4.

%description -l hu.UTF-8
Clementine egy modern zenelejátszó és gyűjtemény kezelő. Túlnyomórészt
az Amarok 1.4 port-ja, néhány funkciója újraírva, hogy kihasználhassa
a Qt4 előnyeit.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

# Remove all 3rdparty libraries exceph universalchardet
# as it is not available as a separate library.
mv 3rdparty 3rdparty.keep
install -d 3rdparty
mv 3rdparty.keep/{universalchardet,sha2,libechonest,qocoa%{?with_static_sqlite:,qsqlite}%{?with_static_projectm:,libprojectM}} 3rdparty

# Don't build tests. They require gmock
sed -i -e '/add_subdirectory(tests)/d' CMakeLists.txt
# remove -Wall
sed -i -e 's/-Wall//' src/CMakeLists.txt
# ...and -Werror
sed -i -e 's/-Werror//' src/CMakeLists.txt

%build
install -d build
install -d build/src/translations
cd build
# as our buildtype is not Release, need to pass these manually. see CMakeLists.txt ~125
CXXFLAGS="%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG_OUTPUT"
%cmake \
	-DBUNDLE_PROJECTM_PRESETS=OFF \
	-DUSE_SYSTEM_QTSINGLEAPPLICATION=ON \
	-DQTSINGLEAPPLICATION_INCLUDE_DIRS=%{_includedir}/qt4/QtSolutions/ \
	-DUSE_SYSTEM_QXT=ON \
	-DUSE_SYSTEM_PROJECTM=ON \
	-DSTATIC_SQLITE=%{?with_static_sqlite:ON}%{!?with_static_sqlite:OFF} \
	..
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

rm $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/scalable/apps/application-x-clementine.svg

# not in our glibc?
rm -r $RPM_BUILD_ROOT%{_localedir}/tr_TR

%find_lang %{name} --with-qm

install -d $RPM_BUILD_ROOT%{_iconsdir}/hicolor/24x24/apps
cp -a dist/icons/ubuntu-mono-light/clementine-panel-grey.png $RPM_BUILD_ROOT%{_iconsdir}/hicolor/24x24/apps/clementine-panel-grey.png
cp -a dist/icons/ubuntu-mono-light/clementine-panel.png $RPM_BUILD_ROOT%{_iconsdir}/hicolor/24x24/apps/clementine-panel.png

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_desktop_database_post
%update_icon_cache hicolor

%postun
%update_desktop_database_postun
%update_icon_cache hicolor

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc Changelog
%attr(755,root,root) %{_bindir}/clementine
%attr(755,root,root) %{_bindir}/clementine-tagreader
%{_desktopdir}/clementine.desktop
%{_pixmapsdir}/clementine.png
%{_iconsdir}/hicolor/*/apps/clementine-panel-grey.png
%{_iconsdir}/hicolor/*/apps/clementine-panel.png
%changelog
* Sat Sep 07 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/clementine.git;a=log;h=master

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> 5fe14c9
- use system libmygpo-qt

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> 6f798db
- add Google Drive support (via Google sparsehash)

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> cb052d7
- suggest gst flac for .flac support

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> fbe6cce
- libimobiledevice patch is not backward compatible

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> aa50641
- update BR, add libspotify bcond

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> 68fe38b
- fix .desktop categories (add Audio); patch from fedora

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> 4a572e4
- fix build with libimobiledevice-1.1.5; patch from fedora

* Sat Sep 07 2013 Elan Ruusamäe <glen@delfi.ee> 7dce784
- BR QtXmlPatterns-devel

* Wed Aug 14 2013 Elan Ruusamäe <glen@delfi.ee> 6b78beb
- rebuild with built in debug

* Sun Jul 14 2013 Jan Rękorajski <baggins@pld-linux.org> 064e709
- disable -Werror
- rel 4

* Sat Mar 30 2013 Elan Ruusamäe <glen@delfi.ee> 862961b
- add R gstreamer0.10-mad for mp3 playback

* Wed Feb 13 2013 Jacek Konieczny <j.konieczny@eggsoft.pl> 49968d1
- BR: qca-devel

* Mon Feb 04 2013 Jan Rękorajski <baggins@pld-linux.org> bdc0a4a
- release 2 (by relup.sh)

* Thu Jan 10 2013 Jacek Konieczny <j.konieczny@eggsoft.pl> dbbdd85
- Version: 1.1.1

* Tue Nov 06 2012 Jan Rękorajski <baggins@pld-linux.org> 7b648e0
- release 5 (by relup.sh)

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> c2c052f
- release 4

* Fri Apr 06 2012 Elan Ruusamäe <glen@pld-linux.org> 4fa200b
- libimobiledevice-1.1.2.patch

* Fri Mar 30 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> a5e288c
- release 2

* Sat Jan 28 2012 Jan Palus <jan.palus@gmail.com> e0ba0da
- up to 1.0.1
- BR: protobuf-devel, qjson-devel
- BR: liblastfm-devel >= 0.3.3 (for <lastfm/ScrobbleCache>)

* Wed Aug 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 59fcb59
- release 4

